#include <stdio.h>
#include <stdlib.h>

void quick_sort(int *a, int start, int end)
{
  /* ... */
}

/*************************************************************/

void check_array(int* a, int* b, int len)
{
  int i;
  for (i = 0; i < len; i++) {
    if (a[i] != b[i]) {
      printf("failed, %d != %d at %d\n", a[i], b[i], i);
      exit(1);
    }
  }
}

void tests() {
  int a1[10] = { 8, 9, 3, 6, 7, 2, 4, 5, 1, 0 };
  int a2[10] = { 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };
  int a3[10] = { 0, 2, 3, 7, 5, 6, 4, 1, 9, 8 };
  int a4[10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
  int s[10] =  { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
  
  quick_sort(a1, 0, 10);
  check_array(a1, s, 10);
  quick_sort(a2, 0, 10);
  check_array(a2, s, 10);
  quick_sort(a3, 0, 10);
  check_array(a3, s, 10);
  quick_sort(a4, 0, 10);
  check_array(a4, s, 10);
}

/*************************************************************/

struct container {
  int count, size;
  int *a;
};

typedef struct container * array_container;

array_container make_array_container() {
  array_container ac;

  ac = (array_container)malloc(sizeof(struct container));
  ac->count = 0;
  ac->size = 1;
  ac->a = (int*)malloc(ac->size * sizeof(int));

  return ac;
}

void copy_array(int* to, int* from, int len) {
  /* copies an array starting from the last item */
  int i;
  for (i = len; i-- > 0; ) {
    to[i] = from[i];
  }
}

void maybe_grow_array(array_container ac) {
  int *new_a;
  if (ac->count >= ac->size) {
    ac->size *= 2;
    new_a = (int*)malloc(ac->size * sizeof(int));
    copy_array(new_a, ac->a, ac->count);
    ac->a = new_a;
  }
}

void add_to_back(array_container ac, int i) {
  maybe_grow_array(ac);

  ac->a[ac->count] = i;
  ac->count++;
}

/*************************************************************/

int main()
{
  array_container ac;
  char buffer[256];
  int i;

  tests();

  ac = make_array_container();
  
  for (; fgets(buffer, 256, stdin); ) {
    add_to_back(ac, atoi(buffer));
  }

  quick_sort(ac->a, 0, ac->count);

  for (i = 0; i < ac->count; i++) {
    printf("%d\n", ac->a[i]);
  }
  
  return 1;
}
